#ifndef __LARUN_H__
#define __LARUN_H__

#ifndef __DLLIM
#define __DLLIM
#define DLLIMBOOL				extern "C" BOOL WINAPI
#define DLLIMINT				extern "C" INT WINAPI
#define DLLIMUINT				extern "C" UINT WINAPI
#define DLLIMLONG				extern "C" LONG WINAPI
#endif
#define DLLIMUINTPTR			extern "C" UINT* WINAPI

#define	UI64				unsigned __int64
#define	I64					__int64

#define TR_CONTINUE			0
#define TR_DISCONTINUE		1
#define TR_END				2

#define TRIG_LOW			0
#define TRIG_HIGH			6
#define TRIG_DONTCARE		8

#define TR_ONELEVEL			0
#define TR_MULTILEVEL		1
#define TR_DUALCOND			2

// _TRIG:iFlag
#define TR_DBLMODE				0x00000001  // LAO_u@bWҦ
#define TR_PRETRIG				0x00000002  // LAO_u@bPre-triggerҦ

typedef struct _TRIG
{
    int         iFlag;          // wqĲo󪺺X
    int         iCh;            // wqTriggerƬOHhChannel(`N,OϥΪChannel)
    int         iLvl;           // wqTriggerh
    int         iDelay;         // Ĳo:Ĳo(쬰Clocks)
    int         iWidth;         // Ĳo:iμeװ(쬰Clocks)
    int         iPassCount;     // Ĳo󪺩
    int         iFreq;          // LAثeu@Wv
    int         iExtend;        // ĲoXjApGȬ2ANN@ťΨŨӨN
    int         iTrMode;        // ĲoҦ(0:涥,1:h,2:,3:e)
	int			iExtClk;		// ϥΥ~ɯ(1:ϥΤ)
	int			iTrPos;			// ĲoI
	int			iFreqHi;		// iFreqHiMiFreqզX@64Bits
	int			iOrs;			// XOR(0,1:@ӱ, 2:ӱ, 3:Tӱ,...)
    int         iOrLvl;			// LBYTE(LOWORD(iOrLvl)) = Levels of OR1, HIYTE(LOWORD(iOrLvl)) = Levels of OR2, ...
    int         *lpiCont;       // ĲoC@hO_sA׬ iLvl (:int)
    BYTE        *lpbTrigData;   // ĲoơA׬ iCh*iLvl (:byte)
} TRIG, FAR *LPTRIG;

DLLIMBOOL ulaInit();
DLLIMBOOL ulaShutdown();
DLLIMBOOL ulaThreshold( int iPod, int iMiniVolt );
DLLIMINT ulaGetHwInfo( UINT nIndex );
DLLIMBOOL ulaSetTrigger( LPTRIG lptr, int *lpi, LPBYTE lpb );
DLLIMBOOL ulaCapture( LPTRIG lptr, int *lpi, LPBYTE lpb );
DLLIMBOOL ulaRead( LPBYTE lpbWave, int iBank );
DLLIMBOOL ulaSetHwInfo( int iIndex, int iValue );
DLLIMBOOL ulaSetHWByPrj(char* szFileName, LPTRIG lptr, int iMemSize);


//LASDK
enum LA_TRIG_TYPE {
		LA_TRIG_DONT_CARE = TRIG_DONTCARE,
		LA_TRIG_LOW = TRIG_LOW,
		LA_TRIG_HIGH = TRIG_HIGH,
		LA_TRIG_RISING = 4, 
		LA_TRIG_FALLING = 2,
		LA_TRIG_CHANGE = 10
};
enum LA_TRIG_NEXT {
		TR_NEXT = TR_CONTINUE,
		TR_NEXTIF = TR_DISCONTINUE, 
		TR_TRIGGER = TR_END 
};
DLLIMBOOL ulaClearTrigger(LPTRIG lptr);
DLLIMBOOL ulaSetChTrigger(LPTRIG lptr, int iLevel, int iCh, int iTrig, int iCondLogic);
DLLIMBOOL ulaBuildTriggerSet(LPTRIG lptr);

DLLIMUINTPTR ulaGetChData(int iCh, UINT* pBuf, int* lpiSize, int p1, int p2, int p3);
DLLIMUINTPTR ulaGetBusData(int iMSB, int iLSB, UINT* pBuf, int* lpiSize, int p1, int p2, int p3);
DLLIMINT ulaGetSamplesNum();

DLLIMBOOL ulaReadTriggerByFile(LPTRIG lptr, char* pTrigFile);
DLLIMBOOL ulaSaveTriggerByFile(LPTRIG lptr, char* pTrigFile);

#pragma pack(1)
typedef struct _TL_QPTN
{
	DWORD		ch_mask_low;					// Channel 31~0	Mask
	DWORD		ch_mask_high	: 4;			// Channel 35~32 Mask
	DWORD		resMA			: 4;			// Reserve
	DWORD		edge_type		: 2;			// 0: Normal, 1: Rising, 2: Falling, 3: Either
	DWORD		save			: 1;			// 0: Match Save, 1: Unmatch Save
	DWORD		resMB			: 4;			// Reserve
	DWORD		enable			: 1;			// 0: Disable Qualification, 1: Enable Qualification
	DWORD		resMC			: 16;			// Reserve
	DWORD		ch_ptn_low;						// Channel 31~0	Pattern
	DWORD		ch_ptn_high		: 4;			// Channel 35~32 Pattern
	DWORD		resPA			: 4;			// Reserve
	DWORD		edge_ch			: 6;			// Edge Channel #
	DWORD		resPB			: 18;
} TL_QPTN, FAR *LPTL_QPTN;
#pragma pack()
#endif