#pragma once
#include "LARun.h"

#define DLLIMVOIDPTR   extern "C" VOID* PASCAL EXPORT
#define DLLIMBOOL   extern "C" BOOL PASCAL EXPORT
#define DLLIMINT   extern "C" INT PASCAL EXPORT
#define DLLIMUINTPTR   extern "C" UINT* PASCAL EXPORT

enum LA_HWMODE
{
	HW_4G_36CH   =  0,	 
	HW_4G_18CH   =  1,	 
	HW_4G_9CH    =  2,	 
	HW_4G_4CH    =  3,	 
	HW_2G_36CH   = 100,
	HW_1600M_4CH = 200,
	HW_800M_9CH  = 300,
	HW_400M_18CH = 400,
	HW_200M_36CH = 500,
	HW_200M_18CH = 501,
	HW_200M_12CH = 502,
	HW_200M_9CH  = 503,
	HW_200M_6CH  = 504,
	HW_200M_4CH  = 505,
	HW_200M_2CH  = 506,
	HW_200M_1CH  = 507,
	HW_EXT_35CH  = 600,
	HW_EXT_18CH  = 601,
	HW_EXT_12CH  = 602,
	HW_EXT_9CH   = 603,
	HW_EXT_6CH   = 604,
	HW_EXT_4CH   = 605,
	HW_EXT_2CH   = 606,
	HW_EXT_1CH   = 607
};

enum HWINFO_INDEX
{
  SET_MEM_SIZE_IN_BYTE = 2,
  SET_TL_MODE = 5,
  SET_TL_QUALIFICATION = 7,
  SET_TL_GLITCH_FILTER = 8,
  SET_TL_CH_MASK = 9,
};
#define TL_MAX_CH_SIZE	26

typedef struct _SDKTRIG
{
    int         iFlag;          // wqĲo󪺺X
    int         iDelay;         // Ĳo:Ĳo(쬰Clocks)
    int         iWidth;         // Ĳo:iμeװ(쬰Clocks)
    int         iPassCount;     // Ĳo󪺩
    int         iFreq;          // LAثeu@Wv
	int			iFreqHi;		// iFreqHiMiFreqզX@64Bits
	int			iExtClk;		// ϥΥ~ɯ(1:ϥΤ)
	int			iTrPos;			// ĲoI
    int         lpiCont[16];       // ĲoC@hO_sA׬ iLvl (:int)
    BYTE        lpbTrigData[1024];   // ĲoơA׬ iCh*iLvl (:byte)
} SDK_TRIG, FAR *LPSDK_TRIG;

typedef struct _TL_QPTN_NONPACK
{
	DWORD ch_mask_low;	// Channel 31~0 Mask
    DWORD ch_mask_high;	// Channel 35~32 Mask
    DWORD edge_type; 	// 0: Normal, 1: Rising, 2: Falling, 3: Either
    DWORD save;			// 0: Match Save, 1: Unmatch Save
    DWORD enable; 		// 0: Disable, 1: Enable
	// Qualification
    DWORD ch_ptn_low; 	// Channel 31~0 Pattern
    DWORD ch_ptn_high;  // Channel 35~32 Pattern
    DWORD edge_ch; 		// Edge Channel #
}TL_QPTN_NONPACK;

DLLIMBOOL ulaSDKInit();
DLLIMINT ulaSDKGetLaID();
DLLIMBOOL ulaSDKClose();
DLLIMBOOL ulaSDKThreshold( int iPod, int iMiniVolt );
DLLIMINT ulaSDKGetHwInfo( UINT nIndex );
DLLIMBOOL ulaSDKSetChTrigger(LPSDK_TRIG lpSDKtr, int iLevel, int iCh, int iTrig, int iCondLogic);
DLLIMBOOL ulaSDKClearTrigger(LPSDK_TRIG lpSDKtr);
DLLIMBOOL ulaSDKCapture( LPSDK_TRIG lpSDKtr);
DLLIMBOOL ulaSDKSetHwInfo( int iIndex, LPVOID lpv);
DLLIMBOOL ulaSDKSetSamplesNum(int iSize);
DLLIMINT ulaSDKGetSamplesNum();
DLLIMINT  ulaSDKGetMaxSamplesNum();
DLLIMBOOL ulaSDKIsCaptureReady();
DLLIMBOOL ulaSDKStopCapture();
DLLIMBOOL ulaSDKGetBusData(int iMSB, int iLSB, UINT* pUserData, int* lpiSize, int iStartSamplePos);
DLLIMBOOL ulaSDKGetChData(int iCh,UINT* pUserData, int* lpiSize, int iStartSamplePos);
DLLIMBOOL ulaSDKSaveTriggerByFile(LPSDK_TRIG lptr, char* szFileName);
DLLIMBOOL ulaSDKReadTriggerByFile(LPSDK_TRIG lptr, char* szFileName);
DLLIMBOOL ulaSDKSetHWByPrj(char* szFileName, LPSDK_TRIG lptr, int iUserMaxMemSize);
DLLIMBOOL ulaSDKSaveAsLawFile(char* szFilePathName);
DLLIMINT ulaSDKGetLastError();
DLLIMBOOL ulaSDKGetSerialNumber(char *szSerialNum, int iSize);
DLLIMBOOL ulaSDKSelectDevice(char* szSerialNo);
DLLIMINT ulaSDKSelectDeviceIdx(int iDeviceIndex);